{$B-}

program _Logo;   { Marek Laco, november 1995. }

uses Dos, Crt, Graph, Marek, Inp, CGAmarek;

const
	 VB = 4;  { Velkost Velkeho Bodu}
	 MaxX = 60;
	 MaxY = 40;

	 mX = 0;
	 mY = 199 - MaxY;

	 sX = 155;
	 sY = 70;

	 gX = 260;
	 gY = 50;


type   _Farby = 0..3;

       _Pole = array[1..MaxX, 1..MaxY] of _Farby;

var
		 Pole: _Pole;
     PomPole, CutPole: _Pole;
	     DATsubor: file of _Pole;
	     IMGsubor: file of pointer;
	     FileName: string[13];
	       Ploska: array[0..3] of pointer;
		Image: pointer;
	I, J, K, Size: word;
	      ImgSize: word;
    CurzCOLOR, Color : _Farby;
		   Ch: char;
		   St: string;
     X, Y, OldX, OldY: integer;
             Zaciatok: boolean;


procedure NewFile;
begin
 for I := 1 to MaxX do for J := 1 to MaxY do Pole[I, J] := 0;
 Writeln;
 Writeln('LOGO - vytvaranie lo''g');
 Writeln('----------------------');
 Writeln;
 Writeln(' F3 load,  F2 save, ESC quit, D draw, INS color, SPC body');
 Writeln;
 Write('**** zadaj meno suboru /bez pripony!/ : ');
 Readln(FileName);
 Writeln;
end;


procedure Hodnoty;
begin
 Color := 1;
 CurzCOLOR := 3;
 X := MaxX div 2;  OldX := 1;
 Y := MaxY div 2;  OldY := 1;
 ImgSize := ImageSize(0, 159, 60, 200);
 GetMem(Image, ImgSize);
end;

procedure Init;
var CGA, M320: Integer;
begin
 ZiadneBGI;
 CGA := 1;
 M320 := 1;
 InitGraph(CGA, M320, '');
end;

procedure Vypln(X, Y: Integer; Color, Border: _Farby);
begin
 SetFillStyle(1, Color);
 FloodFill(X, Y, Border);
end;

procedure DrawCOLOR;
begin
 SetColor(3);
 RectAngle(300, 0, 319, 19);
 for I := 301 to 318 do for J := 1 to 18 do PutPixel(I, J, Color);
end;


procedure DrawBIG(X, Y: integer; Color: _Farby);
var I, J: word;
begin
 PutPixel(mX + X, mY +  Y, Color);
 PutImage(X * VB - VB + 1, Y * VB - VB + 1, Ploska[Color]^, 0);
end;

procedure Curz(X, Y: integer);
begin
 for I := 3 to 4 do for J := 2 to 3 do
  PutPixel(X * VB + J - 0 - VB, Y * VB + I - 1 - VB, CurzCOLOR);
end;


procedure Vykresli;
var X, Y: word;
begin
 SetViewPort(1, 1, MaxX * VB - 1, MaxY * VB - 1, FALSE);
 ClearViewPort;
 SetViewPort(mX, mY, mX + MaxX, mY + MaxY, FALSE);
 ClearViewPort;
 SetViewPort(0, 0, 319, 199, FALSE);
 for X := 1 to MaxX do for Y := 1 to MaxY do
  if Pole[X, Y] > 0 then DrawBIG(X, Y, Pole[X, Y]);
 Zvuk2;
end;

procedure Nakresli;
begin
 DrawBIG(OldX, OldY, Pole[OldX, OldY]);
 DrawBIG(X, Y, Pole[X, Y]);
 Curz(X, Y);
end;

procedure Plus(var Sur: integer);
begin
 Inc(Sur, VB);
end;

procedure Minus(var Sur: integer);
begin
 Dec(Sur, VB);
end;

procedure FlipHor;
begin
 PomPole := Pole;
 for I := 1 to MaxX do for J := 1 to MaxY do
  Pole[MaxX - I + 1, J] := PomPole[I, J];
 Vykresli;
end;

procedure FlipVer;
begin
 PomPole := Pole;
 for I := 1 to MaxX do for J := 1 to MaxY do
  Pole[I, MaxY - J + 1] := PomPole[I, J];
 Vykresli;
end;

procedure Copy;
begin
 CutPole := Pole;
 Zvuk;
end;

procedure Paste;
begin
 Pole := CutPole;
 Zvuk;
 Vykresli;
end;

procedure Koniec;
begin
 CloseGraph;
 Zvuk2;
 Writeln(FileName);
 Writeln;
 Halt(0);
end;

procedure Save;
begin
 Zvuk2;
 Assign(DATsubor, FileName + '.DAT');
 Rewrite(DATsubor);
 Write(DATSubor, Pole);
 Close(DATsubor);
 Zvuk2;
end;

procedure Load;
begin
 Zvuk2;
 Assign(DATsubor, FileName + '.DAT');
 Reset(DATsubor);
 Read(DATsubor, Pole);
 Close(DATsubor);
 Zvuk2;
 Vykresli;
end;

procedure Klavesy;
begin
   Ch := UpCase(Readkey);
   case Ch of
    'H': FlipHor;
    'V': FlipVer;
    'D': begin
	  for I := 1 to MaxX do for J := 1 to MaxY do Pole[I, J] := Color;
	  Vykresli;
	 end;
    #27: Koniec;
    #32: begin
	   if Pole[X, Y] = Color then Pole[X, Y] := 0
	    else Pole[X, Y] := Color;
	   DrawBIG(X, Y, Color);
	  Curz(X, Y);
	 end;
    #00:
     begin
      OldX := X;
      OldY := Y;
      Ch := ReadKey;
      case Ch of
       #60: Save;  { F2 }
       #61: Load;  { F3 }
      end;
      case Klavesa(Ch) of
       8: Dec(Y);
       2: Inc(Y);
       4: Dec(X);
       6: Inc(X);
       9: begin Dec(Y); Inc(X); end;
       7: begin Dec(Y); Dec(X); end;
       3: begin Inc(Y); Inc(X); end;
       1: begin Inc(Y); Dec(X); end;
       0: begin  if Color = 3 then Color := 0 else Inc(Color);
		 DrawCOLOR;
	  end;
      end;
     end;
   end;
  if X = MaxX + 1 then X := 1;
  if X = 0 then X := MaxX;
  if Y = MaxY + 1 then Y := 1;
  if Y = 0 then Y := MaxY;
  case Pole[X, Y] of
     0: CurzCOLOR := 3;
     1: CurzCOLOR := 2;
     2: CurzCOLOR := 1;
     3: CurzCOLOR := 0;
  end;
  Nakresli;
end;

procedure Vyzor;
begin
 InitZvuk;
 Zaciatok := TRUE;
 X := 1; Y := 1;
 for K := 0 to 3 do   { definovanie bodov VB * VB - 0..3 farby }
  begin
   SetColor(K);
   for I := 2 to VB do for J := 1 to VB - 1 do
     PutPixel(X * VB + J - 0 - VB, Y * VB + I - 1 - VB, K);
   Size := ImageSize(X, Y, X * VB - 1, Y * VB - 1);
   GetMem(Ploska[K], Size);
   GetImage(X, Y, X * VB - 1, Y * VB - 1, Ploska[K]^);
  end;
 Cleardevice;
 Logo(259, 30);
 Stempel(259, 100);
 SetColor(3);

 RectAngle(0, 0, MaxX * VB, MaxY * VB);  { BIG }
 X := 1; Y := 1;
 Hodnoty;
 Curz(X, Y);
 DrawCOLOR;
end;


begin
 NewFile;
 Init;
 Vyzor;
 repeat
  Klavesy;
 until GraphResult <> 0;
 CloseGraph;
 Writeln('vnutorna chyba programu, refer to the ML Software !!!');
end.