{$B-}

program Paint;   { Marek Laco, november 1995. }

uses Dos, Crt, Graph, Marek, Inp, CGAmarek;

const
	 VB = 5;  { Velkost Velkeho Bodu}
	 MaxX = 20;
	 MaxY = 20;

	 mX = 150;
	 mY = 30;

	 sX = 155;
	 sY = 70;

	 gX = 210;
	 gY = 30;


type   _Farby = 0..3;

       _Pole = array[1..MaxX, 1..MaxY] of _Farby;

       _Smer = 1..16;

var
		 Pole: array[1..16] of _Pole;
     PomPole, CutPole: _Pole;
		Subor: file of _Pole;
	     FileName: string[13];
	       Ploska: array[0..3] of pointer;
		Image: pointer;
	 Smer, Otocka: _Smer;
	I, J, K, Size: word;
	      ImgSize: word;
    CurzCOLOR, Color : _Farby;
		   Ch: char;
		   St: string;
		  Del: byte;
     X, Y, OldX, OldY: integer;


procedure NewFile;
begin
 Writeln;
 Write('Creating new ', UpStr(FileName));
 Rewrite(Subor);
 for I := 1 to 20 do for J := 1 to 20 do PomPole[I, J] := 0;
 for I := 1 to 16 do Pole[I] := PomPole;
 Writeln;
 Writeln;
end;

procedure Nacitaj;
begin
 Writeln;
 Writeln('Marek Laco SoftWare presents : PAINT the profesional image creating utility');
 Writeln('---------------------------------------------------------------------------');
 Writeln;
 Writeln('mode : 320x200, 4 colors (CGA)    - SHAREWARE - ');
 Writeln;
 Writeln(' *** If you buy a registrated version, you can use all high-resolution modes!');
 Writeln(' *** The registrated PAINT(tm) support all xGA. (up to 1024x768 - true color)');
 Writeln;
 Writeln;

 if ParamCount = 1 then FileName := ParamStr(1)
 else
  begin
   Write(' Enter the image filename: ');
   repeat
    GotoXY(30, WhereY);
    Readln(FileName);
   until Length(FileName) < 13;
   if Length(FileName) = 0 then Abord('filename ?'); 
  end;
 Writeln;
 Writeln('Filename: ' + UpStr(FileName));
 Writeln;

 {$I-}
 Assign(Subor, FileName);
 if Exist(FileName) then
  begin
   Reset(Subor);
   Read(Subor, Pole[1]);
   if IOresult <> 0 then NewFile else
     for I := 2 to 16 do begin Write('.'); Read(Subor, Pole[I]); end;
   Writeln;
   Writeln;
  end
 else NewFile;  
 {$I+}

 if IOresult = 0 then Writeln('OK!') else
   begin
    Close(Subor);
    Abord(' !!! BAD !!!');
   end;

 Delay(500);
end;

procedure Hodnoty;
begin
 Del := 20;
 Smer := 2;
 Otocka := 1;
 Color := 1;
 CurzCOLOR := 3;
 FileName := LowStr(FileName);
 X := MaxX div 2;  OldX := 1;
 Y := MaxY div 2;  OldY := 1;
 ImgSize := ImageSize(1, 1, 20, 20);
 GetMem(Image, ImgSize);
end;

procedure Init;
var CGA, M320: Integer;
begin
 ZiadneBGI;
 CGA := 1;
 M320 := 1;
 InitGraph(CGA, M320, '');
end;

procedure Vypln(X, Y: Integer; Color, Border: _Farby);
begin
 SetFillStyle(1, Color);
 FloodFill(X, Y, Border);
end;

procedure DrawCOLOR;
begin
 SetColor(3);
 RectAngle(300, 0, 319, 19);
 for I := 301 to 318 do for J := 1 to 18 do PutPixel(I, J, Color);
end;


procedure ZacDraw;
begin
 for X := 1 to MaxX do for Y := 1 to MaxY do
   PutPixel(Smer * 20  - 20 - 1 + X, 140 + Y, Pole[Smer, X, Y]);
end;

procedure DrawBIG(X, Y: integer; Color: _Farby);
var I, J: word;
begin
 PutPixel(Smer * 20  - 20 - 1 + X, 140 + Y, Color);

 PutPixel(mX + X, mY +  Y, Color);
 PutImage(X * VB - VB + 1, Y * VB - VB + 1, Ploska[Color]^, 0);
end;

procedure Curz(X, Y: integer);
begin
 for I := 3 to 4 do for J := 2 to 3 do
  PutPixel(X * VB + J - 0 - VB, Y * VB + I - 1 - VB, CurzCOLOR);
end;


procedure Vykresli;
var X, Y: word;
begin
 SetViewPort(1, 1, MaxX * VB - 1, MaxY * VB - 1, FALSE);
 ClearViewPort;
 SetViewPort(mX, mY, mX + MaxX, mY + MaxY, FALSE);
 ClearViewPort;
 SetViewPort(Smer * 20 - 20, 140, Smer * 20 - 1, 160, FALSE);
 ClearViewPort;
 SetViewPort(0, 0, 319, 199, FALSE);
 for X := 1 to MaxX do for Y := 1 to MaxY do
  if Pole[Smer, X, Y] > 0 then DrawBIG(X, Y, Pole[Smer, X, Y]);
 Zvuk2;
end;

procedure Nakresli;
begin
 DrawBIG(OldX, OldY, Pole[Smer, OldX, OldY]);
 DrawBIG(X, Y, Pole[Smer, X, Y]);
 Curz(X, Y);
end;

procedure Plus(var Sur: integer);
begin
 Inc(Sur, VB);
end;

procedure Minus(var Sur: integer);
begin
 Dec(Sur, VB);
end;

procedure FlipHor;
begin
 PomPole := Pole[Smer];
 for I := 1 to MaxX do for J := 1 to MaxY do
  Pole[Smer, MaxX - I + 1, J] := PomPole[I, J];
 Vykresli;
end;

procedure FlipVer;
begin
 PomPole := Pole[Smer];
 for I := 1 to MaxX do for J := 1 to MaxY do
  Pole[Smer, I, MaxY - J + 1] := PomPole[I, J];
 Vykresli;
end;

procedure Copy;
begin
 CutPole := Pole[Smer];
 Zvuk;
end;

procedure Paste;
begin
 Pole[Smer] := CutPole;
 Zvuk;
 Vykresli;
end;


procedure ZmenSmer(Ch: Char);
var P: Longint; H: Char; St: String; C: Integer;
begin

 SetColor(0);
 Str(Smer, St);
 OutTextXY(sX, sY, St);

 case Ch of
    '+': if Smer = 16 then Smer := 1 else Inc(Smer); { TAB }
    '-': if Smer = 1 then Smer := 16 else Dec(Smer);  { S-TAB }
    'S': { zadanie cisla }
	 begin
	  Zvuk; Zvuk;
		 St := '';
		 repeat
		  H := ReadKey;
		  if ord(H) in [48..57] then
		   begin
		    St := St + H;
		    {OutText(H);}
		   end
		   else
		    begin
		     Sound(1600);
		     Delay(130);
		     NoSound;
		    end;
		 until (H = #27) OR (H = #13);
		 Val(St,P,C);
		 if (H <> #27) AND (C = 0) AND (P in [1..16]) then
		  begin
		   Smer := P;
		  end;
	 end;
 end;

 SetColor(3);
 Str(Smer, St);
 OutTextXY(sX, sY, St);
 Vykresli;
end;

procedure Koniec;
begin
 Close(Subor);
 Zvuk2;
 CloseGraph;
 Cls;
 Writeln(' imagefile: ' + FileName);
 Halt(0);
end;

procedure Save;
begin
 Zvuk2;
 Rewrite(Subor);
 for I := 1 to 16 do Write(Subor, Pole[I]);
 Zvuk2;
end;

procedure Klavesy;
begin
   Ch := UpCase(Readkey);
   case Ch of
    'C': Copy;
    'P': Paste;
    'H': FlipHor;
    'V': FlipVer;
    'S': ZmenSmer('S');
    '+': if Del < 200 then Inc(Del);
    '-': if Del > 0 then Dec(Del); 
    'D': begin
	  for I := 1 to MaxX do for J := 1 to MaxY do Pole[Smer, I, J] := Color;
	  Vykresli;
	 end;
    #27: Koniec;
    #09: ZmenSmer('+');
    #32: begin
	   if Pole[Smer, X, Y] = Color then Pole[Smer, X, Y] := 0
	    else Pole[Smer, X, Y] := Color;
	   DrawBIG(X, Y, Color);
	  Curz(X, Y);
	 end;
    #00:
     begin
      OldX := X;
      OldY := Y;
      Ch := ReadKey;
      case Ch of
       #15: ZmenSmer('-');
       #60: Save;  { F2 }
      end;
      case Klavesa(Ch) of
       8: Dec(Y);
       2: Inc(Y);
       4: Dec(X);
       6: Inc(X);
       9: begin Dec(Y); Inc(X); end;
       7: begin Dec(Y); Dec(X); end;
       3: begin Inc(Y); Inc(X); end;
       1: begin Inc(Y); Dec(X); end;
       0: begin  if Color = 3 then Color := 0 else Inc(Color);
		 DrawCOLOR;
	  end;
      end;
     end;
   end;
  if X = MaxX + 1 then X := 1;
  if X = 0 then X := MaxX;
  if Y = MaxY + 1 then Y := 1;
  if Y = 0 then Y := MaxY;
  case Pole[Smer, X, Y] of
     0: CurzCOLOR := 3;
     1: CurzCOLOR := 2;
     2: CurzCOLOR := 1;
     3: CurzCOLOR := 0;
  end;
  Nakresli;
end;

procedure Vyzor;
begin
 InitZvuk;
 X := 1; Y := 1;
 for K := 0 to 3 do   { definovanie bodov VB * VB - 0..3 farby }
  begin
   SetColor(K);
   for I := 2 to VB do for J := 1 to VB - 1 do
     PutPixel(X * VB + J - 0 - VB, Y * VB + I - 1 - VB, K);
   Size := ImageSize(X, Y, X * VB - 1, Y * VB - 1);
   GetMem(Ploska[K], Size);
   GetImage(X, Y, X * VB - 1, Y * VB - 1, Ploska[K]^);
  end;
 Cleardevice;
 Logo(259, 30);
 Stempel(259, 80);
 SetColor(1);
 Line(0, 125, 319, 125);
 Line(0, 165, 319, 165);
 SetColor(2); OutTextXY(80, 110, FileName);
 SetColor(3);
 RectAngle(0, 0, MaxX * VB, MaxY * VB);  { BIG }
 for I := 1 to 16 do
  begin
   Str(I, St);
   OutTextXY(I * 20 - 17, 130, St);
  end;

 for Smer := 1 to 16 do  { nakreslenie 16 obrazkov }
  begin
   ZacDraw;
   if (KeyPressed) AND (Readkey = #27) then Smer := 16;
  end;

 X := 1; Y := 1;
 OutTextXY(0, 110, 'filename:');
 OutTextXY(0, 170, 'SPC puts, TAB - SHIFT+TAB sets number,');
 OutTextXY(0, 180, 'INS color, D fills, S&no&CR quicksets,');
 OutTextXY(0, 190, 'F2 saves, ESC quits, H-V flips');
 Hodnoty;
 ZmenSmer('-');
 Curz(X, Y);
 DrawCOLOR;
end;

procedure Otacaj;
begin
 GetImage(Otocka * 20 - 20, 140, Otocka * 20 - 1, 160, Image^);
 PutImage(gX, gY, Image^, 0);
 if Otocka < 16 then Inc(Otocka) else Otocka := 1;
 if not KeyPressed then for I := 1 to 10 do
   if not KeyPressed then Delay(Del) else I := 10;
end;


begin
 Nacitaj;
 Init;
 Vyzor;
 repeat
  if KeyPressed then Klavesy else Otacaj;
 until GraphResult <> 0;
 CloseGraph;
 Writeln('vnutorna chyba programu, refer to the ML Software !!!');
end.